"use strict";
const form_server_records_1 = require("./form.server.records");
const form_client_records_1 = require("./form.client.records");
const modeljx_1 = require("@redarrowlabs/modeljx");
const MapPascalToCamelCase = (x) => x.charAt(0).toLowerCase() + x.slice(1);
const FormMetaResult_to_Model = modeljx_1.ProjectionBuilder
    .defineProjection(form_server_records_1.ServerFactory.formMetadataRecord, form_client_records_1.ClientFactory.formMetadataRecord)
    .withMapping(MapPascalToCamelCase)
    .build();
const SectionMetaResult_to_Model = modeljx_1.ProjectionBuilder
    .defineProjection(form_server_records_1.ServerFactory.sectionMetadataRecord, form_client_records_1.ClientFactory.sectionMetadataRecord)
    .withMapping(MapPascalToCamelCase)
    .build();
const OptionsResult_to_Model = modeljx_1.ProjectionBuilder
    .defineProjection(form_server_records_1.ServerFactory.dropdownOptionRecord, form_client_records_1.ClientFactory.dropdownOptionRecord)
    .withMapping(MapPascalToCamelCase)
    .build();
const LayoutResult_to_Model = modeljx_1.ProjectionBuilder
    .defineProjection(form_server_records_1.ServerFactory.formInputRecord, form_client_records_1.ClientFactory.formInputRecord)
    .withMapping(MapPascalToCamelCase)
    .override({
    fromProperty: (x) => x.Options,
    toProperty: (x) => x.options,
    use: OptionsResult_to_Model
})
    .build();
const SectionResult_to_Model = modeljx_1.ProjectionBuilder
    .defineProjection(form_server_records_1.ServerFactory.sectionRecord, form_client_records_1.ClientFactory.sectionRecord)
    .withMapping(MapPascalToCamelCase)
    .override({
    forProperty: (x) => x.meta,
    use: SectionMetaResult_to_Model
})
    .override({
    forProperty: (x) => x.layout,
    use: LayoutResult_to_Model
})
    .build();
exports.FormResult_to_Model = modeljx_1.ProjectionBuilder
    .defineProjection(form_server_records_1.ServerFactory.formDefinitionRecord, form_client_records_1.ClientFactory.formDefinitionRecord)
    .withMapping(MapPascalToCamelCase)
    .override({
    forProperty: (x) => x.meta,
    use: FormMetaResult_to_Model
})
    .override({
    forProperty: (from) => from.sections,
    use: SectionResult_to_Model
})
    .build();
//# sourceMappingURL=form.projections.js.map