/// <reference path="../../../node_modules/@types/mocha/index.d.ts" />
"use strict";
const chai_1 = require("chai");
const chai = require("chai");
const form_projections_1 = require("./form.projections");
const form_server_records_1 = require("./form.server.records");
chai.should();
describe('FormResult_to_Model', () => {
    it('projects a blank record properly', () => {
        var form = form_server_records_1.ServerFactory.formDefinitionRecord();
        const projected = form_projections_1.FormResult_to_Model(form);
        chai_1.assert.isNull(projected.meta.formId, 'The default value of formId is null.');
    });
    it('projects a real server model w/out failing', () => {
        const response = {
            "meta": {
                "formId": "the id",
                "instanceId": "the instance",
                "title": "Untitled Form"
            },
            "sections": [
                {
                    "meta": {
                        "sectionId": "the section id",
                        "title": "Untitled Section",
                        "layout": "simple"
                    },
                    "layout": [
                        {
                            "Name": "first-name",
                            "Type": "text",
                            "Label": "My Name",
                            "Required": true,
                            "Options": null
                        },
                        {
                            "Name": "middle-name",
                            "Type": "text",
                            "Label": "Middle Name",
                            "Required": false,
                            "Options": null
                        },
                        {
                            "Name": "last-name",
                            "Type": "text",
                            "Label": "Last Name",
                            "Required": true,
                            "Options": null
                        },
                        {
                            "Name": "birthdate",
                            "Type": "date",
                            "Label": "Birthdate",
                            "Required": true,
                            "Options": null
                        },
                        {
                            "Name": "suffix",
                            "Type": "dropdown-single",
                            "Label": "Suffix",
                            "Required": false,
                            "Options": [
                                {
                                    "Label": "Jr.",
                                    "Value": "Jr."
                                },
                                {
                                    "Label": "Sr.",
                                    "Value": "S"
                                },
                                {
                                    "Label": "III",
                                    "Value": "3"
                                }
                            ]
                        }
                    ]
                }
            ]
        };
        form_projections_1.FormResult_to_Model(response);
    });
});
//# sourceMappingURL=form.projections.spec.js.map