"use strict";
const React = require("react");
const text_input_1 = require("./text-input");
const date_input_1 = require("./date-input");
const dropdown_single_1 = require("./dropdown-single");
exports.InputElementTypes = {
    Text: 'text',
    Date: 'date',
    DropdownSingle: 'dropdown-single'
};
function InputElement(props) {
    const { type, definition } = props;
    switch (type) {
        case exports.InputElementTypes.Text:
            return React.createElement(text_input_1.TextInputElement, { definition: definition });
        case exports.InputElementTypes.Date:
            return React.createElement(date_input_1.DateInputElement, { definition: definition });
        case exports.InputElementTypes.DropdownSingle:
            return React.createElement(dropdown_single_1.DropdownSingleInputElement, { definition: definition });
    }
    return React.createElement("div", null,
        "Not yet supported: ",
        definition.label);
}
exports.InputElement = InputElement;
//# sourceMappingURL=input-element.js.map