"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator.throw(value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const React = require("react");
const forms_client_1 = require("./forms-client");
const section_1 = require("./form-elements/section");
const form_projections_1 = require("./models/form.projections");
class Form extends React.Component {
    constructor(props) {
        super(props);
        this.state = { definition: null };
    }
    // ~todo~ remove this once backend supports sending the full message.
    static wrapServerResponse(layout) {
        return {
            meta: {
                formId: 'the id',
                instanceId: 'the instance',
                title: "Untitled Form"
            },
            sections: [
                {
                    meta: {
                        sectionId: "the section id",
                        title: "Untitled Section",
                        layout: "simple"
                    },
                    layout
                }
            ]
        };
    }
    componentDidMount() {
        return __awaiter(this, void 0, void 0, function* () {
            let { formId } = this.props;
            if (formId) {
                let response = yield forms_client_1.FormsApiClient.Forms
                    .Forms_GetFormById({
                    id: formId
                }, {
                    responseContentType: "application/vnd.api+json"
                });
                let { layouts } = response.obj.data.attributes;
                this.setState({
                    definition: form_projections_1.FormResult_to_Model(Form.wrapServerResponse(layouts))
                });
            }
        });
    }
    render() {
        let { jsonDefinition } = this.props;
        var form = this.state.definition
            ? this.state.definition
            : jsonDefinition;
        if (form) {
            const formTitle = form.meta.title ? React.createElement("h1", { className: "form-title" }, form.meta.title) : '';
            const sections = form.sections.map((item, idx) => React.createElement(section_1.Section, { key: idx, definition: item }));
            return React.createElement("div", { className: "form" },
                formTitle,
                sections);
        }
        return React.createElement("div", null);
    }
}
exports.Form = Form;
//# sourceMappingURL=form.js.map