"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator.throw(value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const SwaggerClient = require("swagger-client");
exports.FormsApiClient = {};
/**
 * Starts the typed API client.
 */
function startFormsClient(swaggerDocUrl) {
    return __awaiter(this, void 0, void 0, function* () {
        exports.FormsApiClient = yield new SwaggerClient({
            url: swaggerDocUrl,
            usePromise: true,
            requestInterceptor: { apply: (req) => requestHandler(req) }
        });
    });
}
exports.startFormsClient = startFormsClient;
function requestHandler(req) {
    const initialError = req.on.error;
    req.on.error = failHandler(initialError);
}
function failHandler(oldErrorFn) {
    return (res) => {
        if (res.status === 0) {
            console.log('The server didn\'t respond to the last request. It might be offline.');
            return;
        }
        if (res.status === 500) {
            let details = getDetails(res);
            console.log(res);
            return;
        }
        oldErrorFn(res);
    };
}
function getDetails(res) {
    if (!res.obj.errors) {
        return res.obj.exceptionMessage;
    }
    if (res.obj.errors.every((x) => !!x.debugException)) {
        return res.obj
            .errors
            .map(prettyPrint)
            .join('<br/>');
    }
    return res.obj.errors.map((e) => e.detail).join('<br/>');
}
function prettyPrint(e) {
    const message = e.debugException.Message;
    const stackTrace = e.debugException.StackTraceString.replace(/(?:\r\n|\r|\n)/g, '<br/>');
    return `${message}<br/>${stackTrace}`;
}
//# sourceMappingURL=forms-client.js.map