"use strict";
const typed_immutable_record_1 = require("typed-immutable-record");
class ClientFactoryImpl {
    constructor() {
        this.formMetadataRecord = typed_immutable_record_1.makeTypedFactory({
            formId: null,
            instanceId: null,
            title: null
        });
        this.formDefinitionRecord = typed_immutable_record_1.makeTypedFactory({
            meta: this.formMetadataRecord(),
            sections: []
        });
        this.sectionMetadataRecord = typed_immutable_record_1.makeTypedFactory({
            title: null,
            sectionId: null,
            layout: 'simple'
        });
        this.sectionRecord = typed_immutable_record_1.makeTypedFactory({
            meta: this.sectionMetadataRecord(),
            layout: []
        });
        this.formInputRecord = typed_immutable_record_1.makeTypedFactory({
            name: 'unknown',
            type: 'unknown',
            label: '',
            required: false,
            options: null
        });
        this.dropdownOptionRecord = typed_immutable_record_1.makeTypedFactory({
            label: '',
            value: ''
        });
    }
}
exports.ClientFactoryImpl = ClientFactoryImpl;
exports.ClientFactory = new ClientFactoryImpl();
//# sourceMappingURL=form.client.records.js.map