"use strict";
const typed_immutable_record_1 = require("typed-immutable-record");
class ServerFactoryImpl {
    constructor() {
        this.formMetadataRecord = typed_immutable_record_1.makeTypedFactory({
            formId: null,
            instanceId: null,
            title: null
        });
        this.formDefinitionRecord = typed_immutable_record_1.makeTypedFactory({
            meta: this.formMetadataRecord(),
            sections: []
        });
        this.sectionMetadataRecord = typed_immutable_record_1.makeTypedFactory({
            title: null,
            sectionId: null,
            layout: 'simple'
        });
        this.sectionRecord = typed_immutable_record_1.makeTypedFactory({
            meta: this.sectionMetadataRecord(),
            layout: []
        });
        this.formInputRecord = typed_immutable_record_1.makeTypedFactory({
            Name: 'unknown',
            Type: 'unknown',
            Label: '',
            Required: false,
            Options: null
        });
        this.dropdownOptionRecord = typed_immutable_record_1.makeTypedFactory({
            Label: '',
            Value: ''
        });
    }
}
exports.ServerFactoryImpl = ServerFactoryImpl;
exports.ServerFactory = new ServerFactoryImpl();
//# sourceMappingURL=form.server.records.js.map